package dao;

import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import dto.Ingredient;
import utils.DS;


public class IngredientDAODatabase {


    private DS ds;
    

    public IngredientDAODatabase(){ 
        this.ds = new DS();     
    }
    public Ingredient findById(int id) {
        try {
            Connection con = ds.getConnection();
            String query = "select * from ingredients where id = " + id + ";";
            ResultSet rs = con.createStatement().executeQuery(query);
            rs.next();
            Ingredient ingredient = new Ingredient(rs.getInt("id"), rs.getString("name"), rs.getDouble("price"));
            con.close();
            return ingredient;
        }
        catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return null;

    }
    public List<Ingredient> findAll() {
        List<Ingredient> ingredients = new ArrayList<Ingredient>();
        try {
            Connection con = ds.getConnection();
            String query = "select * from ingredients;";
            ResultSet rs = con.createStatement().executeQuery(query);
            while (rs.next()) {
                Ingredient ingredient = new Ingredient(rs.getInt("id"), rs.getString("name"), rs.getDouble("price"));
                ingredients.add(ingredient);
            }
            con.close();
        }
        catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return ingredients;
    }

    public void save(Ingredient ingredient)  {
        try {
           
            Connection con = ds.getConnection();           
            String query = "insert into ingredients values (" + ingredient.getId() + ", '" + ingredient.getName() + "', " + ingredient.getPrice() + ");";        
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {System.out.println("l'ingrédient existe déjà");}

    }

    public void delete(int id) {
        try {
            Connection con = ds.getConnection();            
            String query = "delete from ingredients where id = " + id + ";";        
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {System.out.println(e.getMessage());}
    }

    public void update(Ingredient ingredient) {
        try {
            Connection con = ds.getConnection();            
            String query = "update ingredients set name = '" + ingredient.getName() + "', price = " + ingredient.getPrice() + " where id = " + ingredient.getId() +";";        
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {System.out.println(e.getMessage());}
    }

    public void patch(int id ,Ingredient ingredient) {
        // le champ à modifier est la seule valeur non nulle de l'ingrédient
        String champ = "";
        String valeur = "";
        if (ingredient.getName() != null) {
            champ = "name";
            valeur = "'" + ingredient.getName() + "'";
        }
        if (ingredient.getPrice() != null) {
            champ = "price";
            valeur = "" + ingredient.getPrice();
        }       
        try {
            Connection con = ds.getConnection();
           

            String query = "update ingredients set " + champ + " = " + valeur + " where id = " + id + ";";        
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {System.out.println(e.getMessage());}
    }


    public static void main(String[] args) {
        IngredientDAODatabase ingredientDAOList = new IngredientDAODatabase();
        ingredientDAOList.update(new Ingredient(0, "tomate", 1.5));
    }

}


