package dao;

import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;
import dto.Ingredient;
import dto.Pizza;
import dto.PizzaCompo;
import utils.DS;

public class PizzasDAO {
    private DS ds;

    public PizzasDAO() {
        this.ds = new DS();
    }

    public PizzaCompo findByName(String name) {
        try {
            Connection con = ds.getConnection();
            String query = "select * from pizzas where nom = '" + name + "';";
            ResultSet rs = con.createStatement().executeQuery(query);
            rs.next();

            PizzaCompo pizza = new PizzaCompo(rs.getString("nom"), rs.getString("pate"), rs.getDouble("prixBase"));
            query = "select * from pizzas_ingredient where nom = '" + pizza.getNom() + "';";
            ResultSet rs2 = con.createStatement().executeQuery(query);
            while (rs2.next()) {
                int id = rs2.getInt("id");
                Ingredient ingredient = new IngredientDAODatabase().findById(id);
                pizza.addIngredient(ingredient);
            }        
            con.close();
            return pizza;
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return null;
    }

    public List<Pizza> findAll() {
        List<Pizza> pizzas = new ArrayList<Pizza>();
        try {
            Connection con = ds.getConnection();
            String query = "select * from pizzas;";
            ResultSet rs = con.createStatement().executeQuery(query);
            while (rs.next()) {
                Pizza pizza = new Pizza(rs.getString("nom"), rs.getString("pate"), rs.getDouble("prixbase"));
                pizzas.add(pizza);
            }
            con.close();
            return pizzas;
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return null;
    }

    public double totalPrice(String name) {
        try {
            Connection con = ds.getConnection();
            String query = "select * from pizzas where nom = '" + name + "';";
            ResultSet rs = con.createStatement().executeQuery(query);
            rs.next();
            double total = rs.getDouble("prixbase");
            query = "select sum(price) as price from ingredients, pizzas_ingredient as pi where pi.id = ingredients.id and pi.nom = '" + name + "';";
            ResultSet rs2 = con.createStatement().executeQuery(query);
            rs2.next();
            total += rs2.getDouble("price");
            con.close();
            return total;
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return 0;
    }

    public void save(PizzaCompo pizzas) {
        try {
            Connection con = ds.getConnection();
            String query = "insert into pizzas (nom, pate, prixbase) values ('" + pizzas.getNom() + "', '" + pizzas.getPate() + "', " + pizzas.getPrixBase() + ");";
            con.createStatement().executeUpdate(query);

            for (Ingredient ingredient : pizzas.getIngredients()) {
                query = "insert into pizzas_ingredient values ('" + pizzas.getNom() + "', " + ingredient.getId() + ");";
                con.createStatement().executeUpdate(query);
            }
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public void delete(String name) {
        try {
            Connection con = ds.getConnection();
            String query = "delete from pizzas_ingredient where nom = '" + name + "';";
            con.createStatement().executeUpdate(query);
            query = "delete from pizzas where nom = '" + name + "';";
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public void deletePizzaIngredient(String name, int id) {
        try {
            Connection con = ds.getConnection();
            String query = "delete from pizzas_ingredient where nom = '" + name + "' and id = " + id + ";";
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public void addPizzaIngredient(String name, int id) {
        try {
            Connection con = ds.getConnection();
            String query = "insert into pizzas_ingredient values ('" + name + "', " + id + ");";
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public void update(PizzaCompo pizza) {
        try {
            Connection con = ds.getConnection();
            String query = "update pizzas set pate = '" + pizza.getPate() + "', prixbase = " + pizza.getPrixBase() + " where nom = '" + pizza.getNom() + "';";

            // delete all ingredients de la pizza
            query = "delete from pizzas_ingredient where nom = '" + pizza.getNom() + "';";
            con.createStatement().executeUpdate(query);

            for (Ingredient ingredient : pizza.getIngredients()) {
                query = "insert into pizzas_ingredient values ('" + pizza.getNom() + "', " + ingredient.getId() + ");";
                con.createStatement().executeUpdate(query);
            }
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }
    public void patchPizza(String nom ,PizzaCompo pizza){
        try{
            Connection con = ds.getConnection();
            if (pizza.getPate() != null) {
                String query = "update pizzas set pate = '" + pizza.getPate() + "' where nom = '" + nom + "';";
                con.createStatement().executeUpdate(query);
            }
            if (pizza.getPrixBase() != null) {
                
                String query = "update pizzas set prixbase = " + pizza.getPrixBase() + " where nom = '" + nom + "';";
                con.createStatement().executeUpdate(query);
            }
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        if (!pizza.getIngredients().isEmpty()) {
            try{
                Connection con = ds.getConnection();
                String query = "delete from pizzas_ingredient where nom = '" + nom + "';";
                con.createStatement().executeUpdate(query);
                for(Ingredient ingredient : pizza.getIngredients()){
                    query = "insert into pizzas_ingredient values ('" + nom + "', " + ingredient.getId() + ");";
                    con.createStatement().executeUpdate(query);
                }

                con.close();
            } catch (Exception e) {
                System.out.println(e.getMessage());
            }
            
        }
    }
    public boolean findPizzaIngredient(String nom, int id) {
        try {
            Connection con = ds.getConnection();
            String query = "select * from pizzas_ingredient where nom = '" + nom + "' and id = " + id + ";";
            ResultSet rs = con.createStatement().executeQuery(query);
            if (rs.next()) {
                con.close();
                return true;
            }
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return false;
    }

}
