package dao;

import java.sql.Connection;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import dto.Commande;
import dto.CommandeDetail;
import dto.PizzaCompo;
import utils.DS;

public class CommandeDAO {

    private DS ds;

    public CommandeDAO() {
        this.ds = new DS();
    }


    public CommandeDetail findById(int id) {
        try {
            Connection con = ds.getConnection();
            String query = "select * from commandes where id = " + id + ";";
            ResultSet rs = con.createStatement().executeQuery(query);
            rs.next();
            CommandeDetail commande = new CommandeDetail(rs.getInt("id"), rs.getString("nom"), rs.getDate("date"));

            query = "select * from commande_detail where id = " + id + ";";
            rs = con.createStatement().executeQuery(query);
            while (rs.next()) {
                String nom = rs.getString("nom");
                PizzaCompo pizza = new PizzasDAO().findByName(nom);
                commande.addPizza(pizza);
            }
            con.close();        
            return commande;
        }catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return null;
    }

    public List<Commande> findAll() {
        List<Commande> commandes = new ArrayList<Commande>();
        try {
            Connection con = ds.getConnection();
            String query = "select * from commandes;";
            ResultSet rs = con.createStatement().executeQuery(query);
            while (rs.next()) {
                Commande commande = new Commande(rs.getInt("id"), rs.getString("nom"), rs.getDate("date"));
                commandes.add(commande);
            }
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return commandes;
    }

    public void save(CommandeDetail commande) {
        try {
            Connection con = ds.getConnection();
            String query = "insert into commandes values (" + commande.getId() + ", '" + commande.getNom() + "', '" + commande.getDate() + "');";
            con.createStatement().executeUpdate(query);
            for (PizzaCompo pizza : commande.getPizzas()) {
                query = "insert into commande_detail values (" + commande.getId() + ", '" + pizza.getNom() + "');";
                con.createStatement().executeUpdate(query);
            }
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public void delete(int id) {
        try {
            Connection con = ds.getConnection();
            String query = "delete from commandes where id = " + id + ";";
            con.createStatement().executeUpdate(query);
            query = "delete from commande_detail where id = " + id + ";";
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public double totalPrice(int id) {
        double total = 0;
        try {
            Connection con = ds.getConnection();
            String query = "select * from commande_detail where id = " + id + ";";
            ResultSet rs = con.createStatement().executeQuery(query);
            
            while (rs.next()) {
                String nom = rs.getString("nom");
                total += new PizzasDAO().totalPrice(nom);
            }
            con.close();
            

        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return total;
    }

    public void deleteCommandeDetail(int id, String pizza) {
        try {
            Connection con = ds.getConnection();
            String query = "delete from commande_detail where id = " + id + " and nom = '" + pizza + "';";
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public void deleteCommande(int id) {
        try {
            Connection con = ds.getConnection();
            String query = "delete from commande_detail where id = " + id + ";";
            con.createStatement().executeUpdate(query);
            query = "delete from commandes where id = " + id + ";";
            con.createStatement().executeUpdate(query);
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public void update(CommandeDetail commande) {
        try {
            Connection con = ds.getConnection();
            String query = "update commandes set nom = '" + commande.getNom() + "', date = '" + commande.getDate() + "' where id = " + commande.getId() + ";";
            con.createStatement().executeUpdate(query);
            query = "delete from commande_detail where id = " + commande.getId() + ";";
            con.createStatement().executeUpdate(query);
            for (PizzaCompo pizza : commande.getPizzas()) {
                query = "insert into commande_detail values (" + commande.getId() + ", '" + pizza.getNom() + "');";
                con.createStatement().executeUpdate(query);
            }
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
    }

    public void commandePatch(int id, CommandeDetail commande) {
        try {
            Connection con = ds.getConnection();
            if (commande.getNom() != null) {
                String query = "update commandes set nom = '" + commande.getNom() + "' where id = " + id + ";";
                con.createStatement().executeUpdate(query);                
            }
            if (commande.getDate() != null) {
                String query = "update commandes set date = '" + commande.getDate() + "' where id = " + id + ";";
                con.createStatement().executeUpdate(query);                
            }
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        if (!commande.getPizzas().isEmpty()) {
            try {
                Connection con = ds.getConnection();
                String query = "delete from commande_detail where id = " + id + ";";
                con.createStatement().executeUpdate(query);
                for (PizzaCompo pizza : commande.getPizzas()) {
                    query = "insert into commande_detail values (" + id + ", '" + pizza.getNom() + "');";
                    con.createStatement().executeUpdate(query);
                }
                con.close();
            } catch (Exception e) {
                System.out.println(e.getMessage());
            }
            
        }
    }

    public boolean commandeFindPizza(int id, String nom) {
        try {
            Connection con = ds.getConnection();
            String query = "select * from commande_detail where id = " + id + " and nom = '" + nom + "';";
            ResultSet rs = con.createStatement().executeQuery(query);
            if (rs.next()) {
                con.close();
                return true;
            }
            con.close();
        } catch (Exception e) {
            System.out.println(e.getMessage());
        }
        return false;
    }

    public static void main(String[] args) {
        CommandeDAO commandeDAO = new CommandeDAO();
        CommandeDetail commande = commandeDAO.findById(1);
        System.out.println(commande);
        }
    }
