package dto;

import java.util.ArrayList;
import java.util.List;

public class PizzaCompo extends Pizza {

    private List<Ingredient> ingredients = new ArrayList<Ingredient>();

    public PizzaCompo() {
        super();
    }

    public PizzaCompo(String nom, String pate, Double prixBase, Ingredient ingredients) {
        super(nom, pate, prixBase);
        this.ingredients.add(ingredients);
    }

    

    public PizzaCompo(String nom, String pate, Double prixBase) {
        super(nom, pate, prixBase);
        
    }
    public Double totalPrice() {
        Double total = super.getPrixBase() ;
        for (Ingredient ingredient : ingredients) {
            total += ingredient.getPrice();
        }
        return total;
    }
    public List<Ingredient> getIngredients() {
        return ingredients;
    }

    public void setIngredients(List<Ingredient> ingredients) {
        this.ingredients = ingredients;
    }

    public void addIngredient(Ingredient ingredient) {
        this.ingredients.add(ingredient);
    }

    public void removeIngredient(Ingredient ingredient) {
        this.ingredients.remove(ingredient);
    }
    
}
