/* Suppression des tables si elles existent*/
Drop table if exists commande_detail cascade;
Drop table if exists commandes cascade;
Drop table if exists pizzas_ingredients cascade;
Drop table if exists pizzas cascade;
Drop table if exists ingredients cascade;

/* Création des tables */
CREATE TABLE ingredients(
    id int primary key,
    name text,
    price double precision 
    );

CREATE TABLE pizzas(
    nom text primary key,
    pate text,
    prixBase double precision    
    );

CREATE TABLE pizzas_ingredients(
    nom text,
    id int,
    constraint fk_pizza foreign key (nom) references pizzas(nom) ,
    constraint fk_ingredient foreign key (id) references ingredients(id) ,
    primary key (nom,id)   
    );

CREATE TABLE commandes(
    id int primary key,
    nom text,
    date date 
    );

CREATE table commande_detail(
    id int,
    nom text,
    constraint fk_commande foreign key (id) references commandes(id) on delete cascade,
    constraint fk_pizza foreign key (nom) references pizzas(nom),
    primary key (id,nom)
    );

/* Insertion des données */
insert into ingredients values (1,'pomme de terre',1);
insert into ingredients values (3,'chorizo',2);
insert into ingredients values (4,'lardons',2);
insert into ingredients values (5,'aubergines',1);
insert into ingredients values (6,'champignons',1);
insert into ingredients values (10,'fromage',3);
insert into ingredients values (7,'sauce tomate',0.5);
insert into ingredients values (8,'chevre',1.25);
insert into ingredients values (9,'mozzarella',0.75);
insert into ingredients values (2,'crème',2);

insert into pizzas values ('3fromages','classique',3.25);
insert into pizzas values ('4fromages','classique',3.75);
insert into pizzas values ('5fromages','fine',10);
insert into pizzas values ('6fromages','fine',10);

insert into pizzas_ingredients values ('3fromages',10);
insert into pizzas_ingredients values ('3fromages',7);
insert into pizzas_ingredients values ('3fromages',8);
insert into pizzas_ingredients values ('3fromages',9);
insert into pizzas_ingredients values ('6fromages',1);
insert into pizzas_ingredients values ('6fromages',2);
insert into pizzas_ingredients values ('6fromages',3);
insert into pizzas_ingredients values ('6fromages',8);
insert into pizzas_ingredients values ('4fromages',9);
insert into pizzas_ingredients values ('4fromages',8);
insert into pizzas_ingredients values ('4fromages',7);
insert into pizzas_ingredients values ('4fromages',10);

insert into commandes values (1,'jean machin','2024-04-01');
insert into commandes values (2,'jean truc','2024-04-01');
insert into commandes values (3,'jean bidule','2024-04-01');

insert into commande_detail values (1,'3fromages');
insert into commande_detail values (1,'4fromages');
insert into commande_detail values (2,'3fromages');
insert into commande_detail values (2,'4fromages');
insert into commande_detail values (2,'6fromages');
insert into commande_detail values (3,'3fromages');